"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const findEntityForDiff = (propertyName) => {
    return propertyName.includes('xProperties')
        ? 'unclassified'
        : `${propertyName}`;
};
const createSpecEntityDetails = (parsedProperty) => ({
    location: parsedProperty.originalPath.join('.'),
    value: parsedProperty.value
});
exports.createDifference = (options) => {
    const entity = findEntityForDiff(options.propertyName);
    const difference = {
        action: options.action,
        code: `${entity}.${options.action}`,
        destinationSpecEntityDetails: options.destinationSpecOrigins.map(createSpecEntityDetails),
        entity,
        source: options.source,
        sourceSpecEntityDetails: options.sourceSpecOrigins.map(createSpecEntityDetails)
    };
    if (options.details) {
        difference.details = options.details;
    }
    return difference;
};
