"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dereference_object_1 = require("../common/dereference-object");
const parse_openapi3_body_object_json_schema_1 = require("./parse-openapi3-body-object-json-schema");
const toParsedRequestBody = (requestBodyOrReference, pathBuilder, spec) => {
    const requestBody = dereference_object_1.dereferenceObject(requestBodyOrReference, spec);
    const jsonSchema = parse_openapi3_body_object_json_schema_1.parseOpenApi3BodyObjectJsonSchema(requestBody, pathBuilder, spec);
    return {
        jsonSchema,
        originalValue: {
            originalPath: pathBuilder.build(),
            value: requestBody
        }
    };
};
const toParsedUndefinedRequestBody = (pathBuilder) => {
    return {
        originalValue: {
            originalPath: pathBuilder.build(),
            value: undefined
        }
    };
};
exports.parseOpenApi3RequestBody = (requestBodyOrReference, pathBuilder, spec) => {
    return requestBodyOrReference
        ? toParsedRequestBody(requestBodyOrReference, pathBuilder, spec)
        : toParsedUndefinedRequestBody(pathBuilder);
};
