"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parse_x_properties_1 = require("./common/parse-x-properties");
const path_builder_1 = require("./common/path-builder");
const parse_swagger2_paths_1 = require("./swagger2/parse-swagger2-paths");
exports.parseSwagger2Spec = (spec) => {
    const pathBuilder = path_builder_1.PathBuilder.createRootPathBuilder();
    return {
        format: 'swagger2',
        paths: parse_swagger2_paths_1.parseSwagger2Paths(spec.paths, pathBuilder.withChild('paths'), spec),
        xProperties: parse_x_properties_1.parseXPropertiesInObject(spec, pathBuilder)
    };
};
